<?php

/**
 * This class take care of ecommerce tracking setup
 * It renders necessary javascript code to fire events as well as creates dynamic data for the tracking
 * @author woofunnels.
 */
if ( ! class_exists( 'WFFN_Ecomm_Tracking_Optin' ) ) {
	class WFFN_Ecomm_Tracking_Optin extends WFFN_Ecomm_Tracking_Common {
		private static $ins = null;

		public function __construct() {
			parent::__construct();
		}

		/**
		 * @return WFFN_Ecomm_Tracking_Optin|null
		 */
		public static function get_instance() {
			if ( self::$ins === null ) {
				self::$ins = new self();
			}

			return self::$ins;
		}


		public function should_render_view( $type ) {
			if ( $type === 'ga' ) {
				return $this->do_track_ga_view();
			} elseif ( $type === 'fb' ) {

				return $this->do_track_fb_view();
			}

			return false;


		}

		public function do_track_ga_view() {
			$ga_tracking = $this->admin_general_settings->get_option( 'is_ga_page_view_op' );

			if ( is_array( $ga_tracking ) && count( $ga_tracking ) > 0 && 'yes' === $ga_tracking[0] ) {
				return true;
			}

			return false;
		}

		/**
		 * maybe render script to fire fb pixel view event
		 */
		public function do_track_fb_view() {
			$fb_tracking = $this->admin_general_settings->get_option( 'is_fb_page_view_op' );

			if ( is_array( $fb_tracking ) && count( $fb_tracking ) > 0 && 'yes' === $fb_tracking[0] ) {
				return true;
			}

			return false;

		}

		public function should_render( $check_valid_session = false ) {

			if ( parent::should_render( $check_valid_session ) && ( WFOPP_Core()->optin_pages->is_wfop_page() || WFOPP_Core()->optin_ty_pages->is_wfoty_page() ) ) {
				return true;
			}

			return false;
		}

	}
}