/*global wfpxop */
var wffnUtm_terms = ["utm_source", "utm_media", "utm_campaign", "utm_term", "utm_content"], wffnCookieManage = {
    setCookie: function (e, o, t) {
        var r = new Date();
        r.setTime(r.getTime() + 24 * t * 60 * 60 * 1e3);
        var c = "expires=" + r.toUTCString();
        document.cookie = e + "=" + o + ";" + c + ";path=/";
    }, getCookie: function (e) {
        for (var o = e + "=", t = document.cookie.split(";"), r = 0; r < t.length; r++) {
            for (var c = t[r]; " " == c.charAt(0);) c = c.substring(1);
            if (0 == c.indexOf(o)) return c.substring(o.length, c.length);
        }
        return "";
    }, remove: function (e) {
        var o = new Date();
        o.setTime(o.getTime() - 864e5);
        var t = "expires=" + o.toUTCString();
        document.cookie = e + "=;" + t + ";path=/";
    }, commons: {
        inArray: function (e, o) {
            return -1 === o.indexOf(e);
        }
    }
};

function wffnGetQueryVars() {

    try {

        var result = {}, tmp = [];

        window.location.search
            .substr(1)
            .split("&")
            .forEach(function (item) {

                tmp = item.split('=');

                if (tmp.length > 1) {
                    result[tmp[0]] = tmp[1];
                }

            });

        return result;

    } catch (e) {
        console.log(e);
    }

}

function wffnGetTrafficSource() {
    try {

        var referrer = document.referrer.toString();

        var direct = referrer.length === 0;
        //noinspection JSUnresolvedVariable
        var internal = direct ? false : referrer.indexOf(wfpxop.site_url) === 0;
        var external = !(direct || internal);
        var cookie = wffnCookieManage.getCookie('wffn_fb_pixel_traffic_source') === '' ? false : wffnCookieManage.getCookie('wffn_fb_pixel_traffic_source');

        if (external === false) {
            return cookie ? cookie : 'direct';
        } else {
            return cookie && cookie === referrer ? cookie : referrer;
        }

    } catch (e) {

        return '';

    }


}

function wffnManageCookies() {


    try {

        var source = wffnGetTrafficSource();
        if (source !== 'direct') {
            wffnCookieManage.setCookie('wffn_fb_pixel_traffic_source', source, 2);
        } else {
            wffnCookieManage.remove('wffn_fb_pixel_traffic_source');
        }

        var queryVars = wffnGetQueryVars();


        for (var k in wffnUtm_terms) {
            if (wffnCookieManage.getCookie('wffn_fb_pixel_' + wffnUtm_terms[k]) === '' && Object.prototype.hasOwnProperty.call(queryVars, wffnUtm_terms[k])) {

                wffnCookieManage.setCookie('wffn_fb_pixel_' + wffnUtm_terms[k], queryVars[wffnUtm_terms[k]], 2);
            }
        }


    } catch (e) {
        console.log(e);
    }


}

/**
 * Return UTM terms from request query variables or from cookies.
 */
function wffnGetUTMs() {

    try {

        var terms = {};
        var queryVars = wffnGetQueryVars();

        for (var k in wffnUtm_terms) {
            if (wffnCookieManage.getCookie('wffn_fb_pixel_' + wffnUtm_terms[k])) {
                terms[wffnUtm_terms[k]] = wffnCookieManage.getCookie('wffn_fb_pixel_' + wffnUtm_terms[k]);
            } else if (Object.prototype.hasOwnProperty.call(queryVars, wffnUtm_terms[k])) {
                terms[wffnUtm_terms[k]] = queryVars[wffnUtm_terms[k]];
            }
        }

        return terms;

    } catch (e) {
        return {};
    }

}
/* eslint-disable no-unused-vars */
function wffnAddTrafficParamsToEvent(params, mode) {
    if (typeof mode === "undefined") {
        mode = 'fb';
    }
    try {
        var get_generic_params = wfpxop.genericParamEvents;
        var json_get_generic_params = JSON.parse(get_generic_params);

        for (var k in json_get_generic_params) {
            params[k] = json_get_generic_params[k];
        }


        /**
         * getting current day and time to send with this event
         */
        var e = new Date();
        var a = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"][e.getDay()],
            b = ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"][e.getMonth()],
            c = ["00-01", "01-02", "02-03", "03-04", "04-05", "05-06", "06-07", "07-08", "08-09", "09-10", "10-11", "11-12", "12-13", "13-14", "14-15", "15-16", "16-17", "17-18", "18-19", "19-20", "20-21", "21-22", "22-23", "23-24"][e.getHours()];

        params.event_month = b;
        params.event_day = a;
        params.event_hour = c;
        //noinspection JSUnresolvedVariable
        if (false === wfpxop.DotrackTrafficSource[mode]) {
            return params;
        }
        params.traffic_source = wffnGetTrafficSource();


        var getUTMs = wffnGetUTMs();

        for (var ki in getUTMs) {

            params[ki] = getUTMs[ki];

        }
        return params;

    } catch (eeX) {

        return params;

    }
}

wffnManageCookies();